Index: /branches/GeneralizedQAP/HeuristicLab.Algorithms.GRASP/3.3/Plugin.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Algorithms.GRASP/3.3/Plugin.cs.frame	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Algorithms.GRASP/3.3/Plugin.cs.frame	(revision 15504)
@@ -35,5 +35,4 @@
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common", "3.3")]
   [PluginDependency("HeuristicLab.Random", "3.3")]
   [PluginDependency("HeuristicLab.Selection", "3.3")]
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.Designer.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.Designer.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.Designer.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -85,6 +85,6 @@
           if (Content == null) return;
           foreach (var solution in Content.Solutions) {
-            if (solution.OverbookedCapacity.Value <= 0.0) {
-              paretoFrontChart.Series[0].Points.AddXY(solution.FlowDistanceQuality.Value, solution.InstallationQuality.Value);
+            if (solution.Evaluation.ExcessDemand <= 0.0) {
+              paretoFrontChart.Series[0].Points.AddXY(solution.Evaluation.FlowCosts, solution.Evaluation.InstallationCosts);
               paretoFrontChart.Series[0].Points.Last().Tag = solution;
             }
@@ -101,5 +101,5 @@
       if (h.ChartElementType == ChartElementType.DataPoint) {
         var solution = (GQAPSolution)((DataPoint)h.Object).Tag;
-        var assignment = new GQAPAssignment(solution.Assignment, solution.Quality, solution.FlowDistanceQuality, solution.InstallationQuality, solution.OverbookedCapacity, Content.EquipmentNames, Content.LocationNames, Content.Distances, Content.Weights, Content.InstallationCosts, Content.Demands, Content.Capacities, Content.TransportationCosts, Content.ExpectedRandomQuality, Content.Evaluator);
+        var assignment = new GQAPAssignment(solution.Assignment, Content.ProblemInstance, solution.Evaluation);
 
         var view = MainFormManager.MainForm.ShowContent(assignment);
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.Designer.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.Designer.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.Designer.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,5 +28,4 @@
 using HeuristicLab.Common.Resources;
 using HeuristicLab.Core.Views;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.MainForm;
@@ -131,5 +130,5 @@
           qualityLabel.Text = "-";
         } else {
-          qualityLabel.Text = Content.Quality.ToString();
+          qualityLabel.Text = Content.ProblemInstance.ToSingleObjective(Content.Evaluation).ToString();
         }
       }
@@ -139,8 +138,8 @@
       if (InvokeRequired) Invoke((Action)UpdateFlowDistanceQuality);
       else {
-        if (Content == null || Content.FlowDistanceQuality == null) {
+        if (Content == null || Content.Evaluation == null) {
           flowDistanceQualityLabel.Text = "-";
         } else {
-          flowDistanceQualityLabel.Text = Content.FlowDistanceQuality.ToString();
+          flowDistanceQualityLabel.Text = Content.Evaluation.FlowCosts.ToString();
         }
       }
@@ -150,8 +149,8 @@
       if (InvokeRequired) Invoke((Action)UpdateInstallationQuality);
       else {
-        if (Content == null || Content.InstallationQuality == null) {
+        if (Content == null || Content.Evaluation == null) {
           installationQualityLabel.Text = "-";
         } else {
-          installationQualityLabel.Text = Content.InstallationQuality.ToString();
+          installationQualityLabel.Text = Content.Evaluation.InstallationCosts.ToString();
         }
       }
@@ -161,8 +160,8 @@
       if (InvokeRequired) Invoke((Action)UpdateOverbookedCapacity);
       else {
-        if (Content == null || Content.OverbookedCapacity == null) {
+        if (Content == null || Content.Evaluation == null) {
           overbookedCapacityLabel.Text = "-";
         } else {
-          overbookedCapacityLabel.Text = Content.OverbookedCapacity.ToString();
+          overbookedCapacityLabel.Text = Content.Evaluation.ExcessDemand.ToString();
         }
       }
@@ -179,11 +178,11 @@
             if (!locationNodes.ContainsKey(assignment[i])) {
               string locationName = assignment[i].ToString();
-              if (Content.LocationNames != null && Content.LocationNames.Length > assignment[i])
-                locationName = Content.LocationNames[assignment[i]];
+              if (Content.ProblemInstance.LocationNames != null && Content.ProblemInstance.LocationNames.Length > assignment[i])
+                locationName = Content.ProblemInstance.LocationNames[assignment[i]];
               locationNodes.Add(assignment[i], new LocationNode(assignment[i], locationName));
             }
             string equipmentName = i.ToString();
-            if (Content.EquipmentNames != null && Content.EquipmentNames.Length > i)
-              equipmentName = Content.EquipmentNames[i];
+            if (Content.ProblemInstance.EquipmentNames != null && Content.ProblemInstance.EquipmentNames.Length > i)
+              equipmentName = Content.ProblemInstance.EquipmentNames[i];
             locationNodes[assignment[i]].Nodes.Add(new EquipmentNode(i, equipmentName));
           }
@@ -205,5 +204,5 @@
       foreach (var node in GetAllSubNodes(assignmentTreeView.Nodes).OfType<EquipmentNode>()) {
         int location = Content.Assignment[node.Equipment];
-        installationCosts[node] = Content.InstallationCosts[node.Equipment, location];
+        installationCosts[node] = Content.ProblemInstance.InstallationCosts[node.Equipment, location];
       }
       double max = installationCosts.Values.Max();
@@ -224,8 +223,8 @@
       int equipment = selectedNode.Equipment;
       double rowSum = 0, colSum = 0;
-      for (int i = 0; i < Content.Weights.Columns; i++)
-        if (i != equipment) rowSum += Content.Weights[equipment, i];
-      for (int i = 0; i < Content.Weights.Rows; i++)
-        if (i != equipment) colSum += Content.Weights[i, equipment];
+      for (int i = 0; i < Content.ProblemInstance.Weights.Columns; i++)
+        if (i != equipment) rowSum += Content.ProblemInstance.Weights[equipment, i];
+      for (int i = 0; i < Content.ProblemInstance.Weights.Rows; i++)
+        if (i != equipment) colSum += Content.ProblemInstance.Weights[i, equipment];
 
       var otherEquipments = GetAllSubNodes(assignmentTreeView.Nodes)
@@ -240,6 +239,6 @@
           other.ForeColor = assignmentTreeView.ForeColor;
         } else {
-          double rowInvProportion = rowSum == 0 ? 1.0 : (rowSum - Content.Weights[equipment, other.Equipment]) / rowSum;
-          double colInvProportion = colSum == 0 ? 1.0 : (colSum - Content.Weights[other.Equipment, equipment]) / colSum;
+          double rowInvProportion = rowSum == 0 ? 1.0 : (rowSum - Content.ProblemInstance.Weights[equipment, other.Equipment]) / rowSum;
+          double colInvProportion = colSum == 0 ? 1.0 : (colSum - Content.ProblemInstance.Weights[other.Equipment, equipment]) / colSum;
           int colorComponent = (int)(255 * Math.Pow(Math.Min(rowInvProportion, colInvProportion), 2));
           other.BackColor = Color.FromArgb(colorComponent, 255, colorComponent);
@@ -258,7 +257,7 @@
         rowSums[e] = 0;
         colSums[e] = 0;
-        for (int i = 0; i < Content.Weights.Columns; i++) {
-          if (!equipments.Contains(i)) rowSums[e] += Content.Weights[e, i];
-          if (!equipments.Contains(i)) colSums[e] += Content.Weights[i, e];
+        for (int i = 0; i < Content.ProblemInstance.Weights.Columns; i++) {
+          if (!equipments.Contains(i)) rowSums[e] += Content.ProblemInstance.Weights[e, i];
+          if (!equipments.Contains(i)) colSums[e] += Content.ProblemInstance.Weights[i, e];
         }
       }
@@ -272,6 +271,6 @@
           other.ForeColor = assignmentTreeView.ForeColor;
         } else {
-          double rowInvProportion = relevantEquipments.Min(x => rowSums[x] == 0 ? 1.0 : (rowSums[x] - Content.Weights[x, other.Equipment]) / rowSums[x]);
-          double colInvProportion = relevantEquipments.Min(x => colSums[x] == 0 ? 1.0 : (colSums[x] - Content.Weights[other.Equipment, x]) / colSums[x]);
+          double rowInvProportion = relevantEquipments.Min(x => rowSums[x] == 0 ? 1.0 : (rowSums[x] - Content.ProblemInstance.Weights[x, other.Equipment]) / rowSums[x]);
+          double colInvProportion = relevantEquipments.Min(x => colSums[x] == 0 ? 1.0 : (colSums[x] - Content.ProblemInstance.Weights[other.Equipment, x]) / colSums[x]);
           int colorComponent = (int)(255 * Math.Pow(Math.Min(rowInvProportion, colInvProportion), 2));
           other.BackColor = Color.FromArgb(colorComponent, 255, colorComponent);
@@ -314,14 +313,5 @@
 
     private void recalculateButton_Click(object sender, EventArgs e) {
-      double fdq, iq, oc;
-      Content.Evaluator.Evaluate(Content.Assignment, Content.Weights,
-        Content.Distances, Content.InstallationCosts, Content.Demands,
-        Content.Capacities, out fdq, out iq, out oc);
-      Content.FlowDistanceQuality = new DoubleValue(fdq);
-      Content.InstallationQuality = new DoubleValue(iq);
-      Content.OverbookedCapacity = new DoubleValue(oc);
-      Content.Quality = new DoubleValue(
-        Content.Evaluator.GetFitness(fdq, iq, oc,
-        Content.TransportationCosts.Value, Content.ExpectedRandomQuality.Value));
+      Content.Evaluation = Content.ProblemInstance.Evaluate(Content.Assignment);
     }
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/Properties/AssemblyInfo.cs.frame	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/Properties/AssemblyInfo.cs.frame	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -31,5 +31,5 @@
 [assembly: AssemblyCompany("HEAL")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2017 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -54,3 +54,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.6.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.14.$WCREV$")]
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluation/Evaluation.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluation/Evaluation.cs	(revision 15504)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluation/Evaluation.cs	(revision 15504)
@@ -0,0 +1,56 @@
+﻿using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  [Item("GQAP Evaluation", "Class that contains the results of evaluating a solution to the GQAP.")]
+  [StorableClass]
+  public class Evaluation : Item {
+
+    /// <summary>
+    /// The solution is feasible if there is no excess demand
+    /// </summary>
+    public bool IsFeasible { get { return ExcessDemand <= double.Epsilon; } }
+
+    /// <summary>
+    /// The amount of demand that exceeds the respective capacities
+    /// </summary>
+    [Storable]
+    public double ExcessDemand { get; set; }
+    /// <summary>
+    /// The amount of slack at each location, is negative in case of excess demand.
+    /// </summary>
+    /// <remarks>
+    /// Slack.Select(x => x &lt; 0 ? -x : 0).Sum() is equivalent to <see cref="ExcessDemand"/>.
+    /// </remarks>
+    [Storable]
+    public double[] Slack { get; set; }
+    /// <summary>
+    /// The quadratic part of the fitness function that represents the flow or transportation costs.
+    /// </summary>
+    [Storable]
+    public double FlowCosts { get; set; }
+    /// <summary>
+    /// The linear part of the fitness function that represents the installation costs.
+    /// </summary>
+    [Storable]
+    public double InstallationCosts { get; set; }
+    
+    [StorableConstructor]
+    protected Evaluation(bool deserializing) : base(deserializing) { }
+    protected Evaluation(Evaluation original, Cloner cloner)
+      : base(original, cloner) {
+      ExcessDemand = original.ExcessDemand;
+      if (original.Slack != null)
+        Slack = original.Slack.ToArray();
+      FlowCosts = original.FlowCosts;
+      InstallationCosts = original.InstallationCosts;
+    }
+    public Evaluation() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Evaluation(this, cloner);
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluation/GQAPNMoveEvaluator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluation/GQAPNMoveEvaluator.cs	(revision 15504)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluation/GQAPNMoveEvaluator.cs	(revision 15504)
@@ -0,0 +1,135 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  [Item("N-Move Evaluator", "Evaluates an N-Move.")]
+  [StorableClass]
+  public class GQAPNMoveEvaluator : SingleSuccessorOperator, IGQAPNMoveEvaluator,
+    IQualityAwareGQAPOperator, IProblemInstanceAwareGQAPOperator {
+
+    #region Parameter Descriptions
+    public static readonly string MoveQualityDescription = "The quality of the move if it would be applied.";
+    public static readonly string MoveEvaluationDescription = "The results of evaluating the move.";
+    #endregion
+
+    #region Parameter Properties
+    public ILookupParameter<DoubleValue> MoveQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["MoveQuality"]; }
+    }
+    public ILookupParameter<Evaluation> MoveEvaluationParameter {
+      get { return (ILookupParameter<Evaluation>)Parameters["MoveEvaluation"]; }
+    }
+    public ILookupParameter<NMove> MoveParameter {
+      get { return (ILookupParameter<NMove>)Parameters["Move"]; }
+    }
+    public ILookupParameter<IntegerVector> AssignmentParameter {
+      get { return (ILookupParameter<IntegerVector>)Parameters["Assignment"]; }
+    }
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public ILookupParameter<Evaluation> EvaluationParameter {
+      get { return (ILookupParameter<Evaluation>)Parameters["Evaluation"]; }
+    }
+    public ILookupParameter<GQAPInstance> ProblemInstanceParameter {
+      get { return (ILookupParameter<GQAPInstance>)Parameters["ProblemInstance"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected GQAPNMoveEvaluator(bool deserializing) : base(deserializing) { }
+    protected GQAPNMoveEvaluator(GQAPNMoveEvaluator original, Cloner cloner) : base(original, cloner) { }
+    public GQAPNMoveEvaluator()
+      : base() {
+      Parameters.Add(new LookupParameter<IntegerVector>("Assignment", GQAPSolutionCreator.AssignmentDescription));
+      Parameters.Add(new LookupParameter<NMove>("Move", GQAPNMoveGenerator.MoveDescription));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", ""));
+      Parameters.Add(new LookupParameter<Evaluation>("Evaluation", GQAP.EvaluationDescription));
+      Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", MoveQualityDescription));
+      Parameters.Add(new LookupParameter<Evaluation>("MoveEvaluation", MoveEvaluationDescription));
+      Parameters.Add(new LookupParameter<GQAPInstance>("ProblemInstance", GQAP.ProblemInstanceDescription));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GQAPNMoveEvaluator(this, cloner);
+    }
+
+    public static Evaluation Evaluate(NMove move, IntegerVector assignment, Evaluation evaluation, GQAPInstance problemInstance) {
+      int moves = move.N;
+      var newEvaluation = new Evaluation() {
+        ExcessDemand = evaluation.ExcessDemand,
+        FlowCosts = evaluation.FlowCosts,
+        InstallationCosts = evaluation.InstallationCosts,
+        Slack = evaluation.Slack.ToArray()
+      };
+      foreach (var kvp in move.NewAssignments) {
+        int equip = kvp.Key;
+        int newLoc = kvp.Value;
+        int oldLoc = assignment[equip];
+        var equipDemand = problemInstance.Demands[equip];
+        newEvaluation.InstallationCosts -= problemInstance.InstallationCosts[equip, oldLoc];
+        newEvaluation.InstallationCosts += problemInstance.InstallationCosts[equip, newLoc];
+        for (int j = 0; j < assignment.Length; j++) {
+          if (!move.NewAssignments.ContainsKey(j)) {
+            newEvaluation.FlowCosts += problemInstance.Weights[equip, j] * problemInstance.Distances[newLoc, assignment[j]];
+            newEvaluation.FlowCosts -= problemInstance.Weights[equip, j] * problemInstance.Distances[oldLoc, assignment[j]];
+            newEvaluation.FlowCosts += problemInstance.Weights[j, equip] * problemInstance.Distances[assignment[j], newLoc];
+            newEvaluation.FlowCosts -= problemInstance.Weights[j, equip] * problemInstance.Distances[assignment[j], oldLoc];
+          } else {
+            newEvaluation.FlowCosts += problemInstance.Weights[equip, j] * problemInstance.Distances[newLoc, move.NewAssignments[j]];
+            newEvaluation.FlowCosts -= problemInstance.Weights[equip, j] * problemInstance.Distances[oldLoc, assignment[j]];
+          }
+        }
+        newEvaluation.Slack[oldLoc] += equipDemand;
+        if (newEvaluation.Slack[oldLoc] < equipDemand)
+          newEvaluation.ExcessDemand -= Math.Min(equipDemand, equipDemand - newEvaluation.Slack[oldLoc]);
+        newEvaluation.Slack[newLoc] -= equipDemand;
+        if (newEvaluation.Slack[newLoc] < 0)
+          newEvaluation.ExcessDemand += Math.Min(equipDemand, -newEvaluation.Slack[newLoc]);
+      }
+
+      return newEvaluation;
+    }
+
+    public override IOperation Apply() {
+      var problemInstance = ProblemInstanceParameter.ActualValue;
+      var evaluation = EvaluationParameter.ActualValue;
+
+      var moveEvaluation = Evaluate(MoveParameter.ActualValue,
+               AssignmentParameter.ActualValue,
+               evaluation,
+               problemInstance);
+
+      MoveEvaluationParameter.ActualValue = moveEvaluation;
+      return base.Apply();
+    }
+  }
+}
